unit U_SalesConInPutCopy;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridLevel, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxClasses, cxControls, cxGridCustomView, cxGrid, cxMemo,
  cxRichEdit, ComCtrls, cxContainer, cxTextEdit, cxMaskEdit, cxButtonEdit,
  StdCtrls, ToolWin, DBClient, ADODB, ExtCtrls, BtnEdit, cxCalendar, StrUtils,
  cxDropDownEdit, cxGridCustomPopupMenu, cxGridPopupMenu, cxLookAndFeels,
  cxLookAndFeelPainters, dxSkinsCore, dxSkinsDefaultPainters, cxNavigator,
  dxDateRanges, dxBarBuiltInMenu, dxDateTimeWheelPicker, dxGDIPlusClasses,
  Vcl.Menus, MovePanel, cxCheckBox, cxImage, cxDBEdit, Vcl.DBCtrls, U_BaseInput,
  System.ImageList, Vcl.ImgList, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdExplicitTLSClientServerBase, IdFTP, ShellAPI;

type
  TfrmSalesConInPutCopy = class(TfrmBaseInput)
    ToolBar1: TToolBar;
    TBSave: TToolButton;
    TBClose: TToolButton;
    ScrollBox1: TScrollBox;
    Label3: TLabel;
    ConDate: TDateTimePicker;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ADOTemp: TADOQuery;
    ADOCmd: TADOQuery;
    DS_1: TDataSource;
    Order_Sub: TClientDataSet;
    Label9: TLabel;
    Label10: TLabel;
    ConNo: TEdit;
    Label14: TLabel;
    Label20: TLabel;
    BuyName: TBtnEditC;
    Label6: TLabel;
    Label34: TLabel;
    BuyConNo: TEdit;
    cxgrdpmn1: TcxGridPopupMenu;
    QtyNote: TBtnEditC;
    Sellname: TBtnEditC;
    MiddleName: TBtnEditC;
    Label26: TLabel;
    Label27: TLabel;
    IsTax: TComboBox;
    Label29: TLabel;
    Label30: TLabel;
    QiYun: TBtnEditC;
    MuDi: TBtnEditC;
    Label2: TLabel;
    ExchangeRate: TEdit;
    Label5: TLabel;
    Currency: TComboBox;
    Label7: TLabel;
    YongJin: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    YunShu: TBtnEditC;
    Payment: TBtnEditC;
    Label4: TLabel;
    GSChuanYangNote: TBtnEditC;
    Label13: TLabel;
    JiaGeSY: TBtnEditC;
    Label1: TLabel;
    CKChuanYangNote: TBtnEditC;
    pm_sub: TPopupMenu;
    N1: TMenuItem;
    Pic_Image1: TcxDBImage;
    DataSource1: TDataSource;
    ADOQueryImage: TADOQuery;
    MTieJing: TRichEdit;
    cxDBImage1: TcxDBImage;
    DS_ImgHX: TDataSource;
    Qry_ImgHX: TADOQuery;
    IdFTP1: TIdFTP;
    Label8: TLabel;
    Packing: TBtnEditC;
    Label15: TLabel;
    Label16: TLabel;
    DlyDate: TDateTimePicker;
    YFTPName: TBtnEditC;
    Label17: TLabel;
    N2: TMenuItem;
    ShippMent: TEdit;
    ToolButton3: TToolButton;
    Label23: TLabel;
    ConType: TComboBox;
    Label24: TLabel;
    Saleser: TEdit;
    Tallyer: TEdit;
    lblSalesId: TLabel;
    Label25: TLabel;
    SalesId: TEdit;
    TallyId: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    Booker: TComboBox;
    Label21: TLabel;
    WeightNote: TBtnEditC;
    Label22: TLabel;
    VolumeEstimation: TBtnEditC;
    Label28: TLabel;
    Panel1: TPanel;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    Tv1Column7: TcxGridDBColumn;
    v1XHNo: TcxGridDBColumn;
    VC_SCSCode: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    Tv1Column3: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    Tv1Column5: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column8: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1PRTOrderQty: TcxGridDBColumn;
    v1OrderUnit: TcxGridDBColumn;
    v1PRTPrice: TcxGridDBColumn;
    Tv1Column9: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    cxGrid1Level1: TcxGridLevel;
    ScrollBox2: TScrollBox;
    Note: TMemo;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    PBPrice: TEdit;
    RPrice: TEdit;
    suolv: TEdit;
    MQty: TEdit;
    GY1Price: TEdit;
    GY2Price: TEdit;
    GY3Price: TEdit;
    PackPrice: TEdit;
    exchange: TEdit;
    freight: TEdit;
    brokerage: TEdit;
    Tv1Column2: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    ADOQuery1: TADOQuery;
    ADOQuery2: TADOQuery;
    Button1: TButton;
    Label40: TLabel;
    Label44: TLabel;
    Estimated: TEdit;
    ProfitRate: TEdit;
    ConPrice: TEdit;
    ConSid: TEdit;
    ADOQuery3: TADOQuery;
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure BuyNameBtnUpClick(Sender: TObject);
    procedure BuyNameBtnDnClick(Sender: TObject);
    procedure v1Column4PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1Column6PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1Column7PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1Column10PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure SalesmanBtnUpClick(Sender: TObject);
    procedure v1Column15PropertiesEditValueChanged(Sender: TObject);
    procedure SellNameBtnUpClick(Sender: TObject);
    procedure MiddleNameBtnUpClick(Sender: TObject);
    procedure v1PRTOrderQtyPropertiesEditValueChanged(Sender: TObject);
    procedure QiYunBtnUpClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure Pic_Image1DblClick(Sender: TObject);
    procedure cxDBImage1DblClick(Sender: TObject);
    procedure YFTPNameBtnUpClick(Sender: TObject);
    procedure MTieJingDblClick(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ExchangeRateKeyPress(Sender: TObject; var Key: Char);
    procedure ShippMentKeyPress(Sender: TObject; var Key: Char);
    procedure ShippMentChange(Sender: TObject);
    procedure Tv1FocusedRecordChanged(Sender: TcxCustomGridTableView; APrevFocusedRecord, AFocusedRecord: TcxCustomGridRecord; ANewItemRecordFocusingChanged: Boolean);
    procedure PBPriceKeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
  private
    FLeft, FTop: Integer;
    fuserName, Fstatus: string;
    procedure InitImage();
    procedure InitGX();
    procedure JSMoney();
//    procedure JSCB();
    procedure InitData();
    procedure ZDYHelp(FButn: TcxButtonEdit; LType: string);
    function TestData(): Boolean;
    function SaveData(): Boolean;
    procedure SetXH();
    procedure LookImage(FileName: string);
    { Private declarations }
  public
    CopyInt: Integer;
    PState: string;
    fFlileFlag: string;
    FConMId: string;
    FAuthority, FGSTT: string;
    { Public declarations }
  end;

var
  frmSalesConInPutCopy: TfrmSalesConInPutCopy;
  newh: hwnd;

implementation

uses
  U_DataLink, U_RTFun, U_ZDYHelp, U_CompanySel, U_ClothInfoSel, U_PictureUpload;

{$R *.dfm}

procedure TfrmSalesConInPutCopy.SetXH();
var
  i: Integer;
begin
  with Order_Sub do
  begin
    First;
    i := 1;
    while not Eof do
    begin
      with Order_Sub do
      begin
        Edit;
        FieldByName('XHNoTemp').Value := i;
        Post;
      end;
      i := i + 1;
      Next;
    end;
  end;

  with Order_Sub do
  begin
    Order_Sub.IndexFieldNames := '';
    First;
    i := 1;
    while not Eof do
    begin
      with Order_Sub do
      begin
        Edit;
        FieldByName('SerialNo').Value := FieldByName('XHNoTemp').AsInteger;
        Post;
      end;
      i := i + 1;
      Next;
    end;
    Order_Sub.IndexFieldNames := 'SerialNo';
  end;
end;

procedure TfrmSalesConInPutCopy.ShippMentChange(Sender: TObject);
begin
  if ShippMent.text <> '' then
  begin
    Dlydate.DateTime := ConDate.DateTime + StrToFloat(Shippment.text);
  end;

end;

procedure TfrmSalesConInPutCopy.ShippMentKeyPress(Sender: TObject; var Key: Char);
begin
  if not (((Key >= '0') and (Key <= '9')) or (Key = '.') or (Key = #8)) then
  begin
    Key := #0;
  end
  else if (pos('.', TEdit(Sender).text) <> 0) then
  begin
    if Key = '.' then
    begin
      Key := #0;
    end;
  end;

end;

procedure TfrmSalesConInPutCopy.InitImage();
begin
  with ADOQueryImage do
  begin
    close;
    sql.Clear;
    sql.Add('select * from TP_File A');
    sql.Add('where isnull(WBID,'''')<>'''' and FileName=' + quotedstr(Trim(YFTPName.Text)));
//    showmessage(sql.text);        Self..Text
    open;
  end;
end;

procedure TfrmSalesConInPutCopy.InitGX();
var
  i: Integer;
  xh: string;
begin
  if Order_Sub.IsEmpty then
    exit;
  with ADOQuery1 do
  begin
    close;
    sql.Clear;
    sql.Add('select * from BS_Cloth_Glide  A  ');
    sql.Add('left join Bs_Cloth_Info B on A.BCIID=B.BCIID');
    sql.Add('where B.C_Code =' + quotedstr((Order_sub.fieldbyname('C_Code').AsString)));
    open;
  end;
  i := 1;
  xh := '1';
//  if ADOQuery1.ISEmpty = False then
//  begin

  while i <= 3 do
  begin
    with ADOQuery2 do
    begin
      close;
      sql.Clear;
      sql.Add('select  A.* from (select X.ProcessName+''-''+X.ProcessTypeName AS GX,X.BCIID,X.GlideIdx from BS_Cloth_Glide X) A  ');
      sql.Add('left join Bs_Cloth_Info B on A.BCIID=B.BCIID');
      sql.Add('where B.C_Code =' + quotedstr((Order_sub.fieldbyname('C_Code').AsString)));
      sql.Add('and A.GlideIdx =''' + Trim(xh) + '''');
//        showmessage(SQL.text);
      open;
    end;

    case i of
      1:
        begin
          if Trim(ADOQuery2.fieldbyname('GX').AsString) <> '' then
          begin
            Label36.Caption := Trim(ADOQuery2.fieldbyname('GX').AsString) + '加工费:';
          end
          else
          begin
            Label36.Caption := '工艺1加工费：';
          end;

        end;
      2:
        begin
          if Trim(ADOQuery2.fieldbyname('GX').AsString) <> '' then
          begin
            Label37.Caption := Trim(ADOQuery2.fieldbyname('GX').AsString) + '加工费:';
          end
          else
          begin
            Label37.Caption := '工艺2加工费：';
          end;
        end;
      3:
        begin
          if Trim(ADOQuery2.fieldbyname('GX').AsString) <> '' then
          begin
            Label38.Caption := Trim(ADOQuery2.fieldbyname('GX').AsString) + '加工费:';
          end
          else
          begin
            Label38.Caption := '工艺3加工费：';
          end;
        end;
    end;

    i := i + 1;
    xh := IntToStr(i);
//    end;
  end;

end;

procedure TfrmSalesConInPutCopy.JSMoney();
var
  FConQty, FConPrice, FC_Money: Double;
begin
  with Order_Sub do
  begin
    FConQty := Fieldbyname('ConQty').AsFloat;
    FConPrice := Fieldbyname('ConPrice').AsFloat;
  end;
  //计算金额，保留2位小数
  FC_Money := RoundFloat(FConQty * FConPrice, 2);
  with Order_Sub do
  begin
    Edit;
    FieldByName('ConTotalAmount').Value := FC_Money;
    Post;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

//procedure TfrmSalesConInPut.JSCB();

//
//  //计算金额，保留2位小数
//  FC_Money := RoundFloat(FConQty * FConPrice, 2);
//  with Order_Sub do
//  begin
//    Edit;
//    FieldByName('ConTotalAmount').Value := FC_Money;
//    Post;
//  end;
//  tv1.Controller.EditingController.ShowEdit();
//end;

function TfrmSalesConInPutCopy.TestData(): Boolean;
begin
  try
    if Trim(ConNo.Text) = '' then
      raise Exception.Create('合同号不能为空！');
    if Trim(SellName.Text) = '' then
      raise Exception.Create('经营单位不能为空！');
    if Trim(BuyName.Text) = '' then
      raise Exception.Create('对方单位不能为空！');
    if Trim(ConType.Text) = '' then
      raise Exception.Create('类型不能为空！');
    if Order_Sub.IsEmpty then
      raise Exception.Create('明细不能为空！');
    if Order_Sub.Locate('C_Code', null, []) then
      raise Exception.Create('产品编号不能为空！');
    if Order_Sub.Locate('C_Code', '', []) then
      raise Exception.Create('产品编号不能为空！');
    if Order_Sub.Locate('C_Name', null, []) then
      raise Exception.Create('品名不能为空！');
    if Order_Sub.Locate('C_Name', '', []) then
      raise Exception.Create('品名不能为空！');
    if Order_Sub.Locate('C_Color', null, []) then
      raise Exception.Create('颜色不能为空！');
    if Order_Sub.Locate('C_Color', '', []) then
      raise Exception.Create('颜色不能为空！');
//    if Order_Sub.Locate('C_MF', null, []) then
//      raise Exception.Create('门幅不能为空！');
//    if Order_Sub.Locate('C_MF', '', []) then
//      raise Exception.Create('门幅不能为空！');
//    if Order_Sub.Locate('C_KZ', null, []) then
//      raise Exception.Create('克重不能为空！');
//    if Order_Sub.Locate('C_KZ', '', []) then
//      raise Exception.Create('克重不能为空！');
    if Order_Sub.Locate('ConQty', null, []) then
      raise Exception.Create('数量不能为空！');
    if Order_Sub.Locate('ConQty', 0, []) then
      raise Exception.Create('数量不能为0！');
    if Order_Sub.Locate('ConUnit', null, []) then
      raise Exception.Create('数量单位不能为空！');
    if Order_Sub.Locate('ConUnit', '', []) then
      raise Exception.Create('数量单位不能为空！');
    Result := True;
  except
    Result := false;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;
end;

procedure TfrmSalesConInPutCopy.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmSalesConInPutCopy.InitData();
var
  maxno: string;
begin
  //刷新产品信息
  with ADOTemp do
  begin
    Close;
    SQL.Clear;
    sql.Add(' select * from BS_Contract_Sub ');
    sql.Add('where ConMId=''' + Trim(FConMId) + '''');
//    sql.Add(' order by SerialNo ');
    Open;
  end;
  SCreateCDS(ADOTemp, Order_Sub);
  SInitCDSData(ADOTemp, Order_Sub);
//  SCSHData(ADOTemp, ScrollBox2, 1);
   //刷新条款信息
  with ADOTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from BS_Contract_Main where ConMId=''' + Trim(FConMId) + '''');
    Open;
  end;
  SCSHData(ADOTemp, ScrollBox1, 2);
  BuyName.TxtCode := Trim(ADOTemp.FieldByName('BuyNo').AsString);
  Sellname.TxtCode := Trim(ADOTemp.FieldByName('SellNo').AsString);
  MiddleName.TxtCode := Trim(ADOTemp.FieldByName('MiddleNo').AsString);
  Fstatus := Trim(ADOTemp.FieldByName('status').AsString);

  if PState = '新增' then
  begin
    ConDate.DateTime := SGetServerDateTime(ADOTemp);
    DlyDate.DateTime := ConDate.DateTime;
    ConNo.Text := '自动生成';

  end;

  if PState = '复制' then
  begin

    PState := '新增';
    FConMId := '';
    ConNo.Text := '自动生成';

    with Order_Sub do
    begin
      First;
      while not Eof do
      begin
        if GetLSNo(ADOCmd, maxno, 'SCS', 'BS_Contract_Sub', 4, 1) = False then
        begin
          Application.MessageBox('取子流水号失败！', '提示', 0);
          Exit;
        end;
        Edit;
        FieldByName('ConMId').Value := '';
        FieldByName('ConSId').Value := maxno;
        Post;
        Next;
      end;
    end;
  end;

end;

procedure TfrmSalesConInPutCopy.MiddleNameBtnUpClick(Sender: TObject);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '客户';
      if Self.FAuthority = '录入' then
        FAuthority := '理单业务';
      if ShowModal = 1 then
      begin
        self.MiddleName.TxtCode := Trim(frmCompanySel.CDS_1.fieldbyname('CoCode').AsString);
        self.MiddleName.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoName').AsString);
      end;
    end;
  finally
    frmCompanySel.Free;
  end;
end;

procedure TfrmSalesConInPutCopy.MTieJingDblClick(Sender: TObject);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
//      flag := 'TJ' + TRIM(Order_Sub.fieldbyname('C_Code').AsString) + TRIM(BuyName.TxtCode);
      flag := 'TJ';
      flagname := '贴金';
      if ShowModal = 1 then
      begin
        MTieJing.Text := StringReplace(Trim(ClientDataSet1.fieldbyname('ZDYName').AsString), '#', #$D#$A, [rfReplaceAll]);

      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmSalesConInPutCopy.N1Click(Sender: TObject);
var
  FValue, FFValue, FColumn, FFColumn, MHXSID: string;
  MXHNO: Integer;
begin
//  if Fstatus = '1' then
//  begin
//    application.MessageBox('合同已审核，无法操作！', '提示信息', 0);
//    exit;
//  end;
//  MXHNO := Order_Sub.FieldByName('XHNo').ASInteger;
//  FColumn := Tv1.Controller.FocusedColumn.DataBinding.FilterFieldName;
//  FValue := Trim(Order_Sub.fieldbyname(FColumn).AsString);
//  MHXSID := Trim(Order_Sub.fieldbyname('HXSID').AsString);
//  with Order_Sub do
//  begin
//    DisableControls;
//    First;
//    while not Eof do
//    begin
//      if FieldByName('SSel').AsBoolean then
//      begin
//        Edit;
//
//        if FValue = '' then
//        begin
//          Order_Sub.FieldByName(FColumn).Value := null;
//        end
//        else
//        begin
//          Order_Sub.FieldByName(FColumn).Value := FValue;
//        end;
//        if FColumn = 'C_HX' then
//        begin
//          Order_Sub.FieldByName('HXSID').Value := MHXSID;
//        end;
//        Post;
//        JSMoney();
//      end;
//      Next;
//    end;
//    EnableControls;
//  end;
//  Order_Sub.Locate('XHNO', MXHNO, []);
end;

procedure TfrmSalesConInPutCopy.N2Click(Sender: TObject);
var
  FValue, MC_Code, MC_Craft, MC_Name, MC_Spec, MC_CF, MC_Color, MC_MF, MC_KZ, MC_Note, MC_Unit, MGcHuaNo, MSuoLv, MC_EName: string;
  MXHNO: Integer;
begin
//  if Fstatus = '1' then
//  begin
//    application.MessageBox('合同已审核，无法操作！', '提示信息', 0);
//    exit;
//  end;
//
//  MXHNO := Order_Sub.FieldByName('XHNo').ASInteger;
//  MC_Code := Order_Sub.fieldbyname('C_Code').AsString;
//  MC_Craft := Order_Sub.fieldbyname('C_Craft').AsString;
//  MC_Name := Order_Sub.fieldbyname('C_Name').AsString;
//  MC_Spec := Order_Sub.fieldbyname('C_Spec').AsString;
//  MC_CF := Order_Sub.fieldbyname('C_CF').AsString;
//  MC_Color := Order_Sub.fieldbyname('C_Color').AsString;
//  MC_MF := Order_Sub.fieldbyname('C_MF').AsString;
//  MC_KZ := Order_Sub.fieldbyname('C_KZ').AsString;
//  MC_Note := Order_Sub.fieldbyname('C_Note').AsString;
//  MC_Unit := Order_Sub.fieldbyname('C_Unit').AsString;
//  MSuoLv := Order_Sub.fieldbyname('SuoLv').AsString;
//  MGcHuaNo := Order_Sub.fieldbyname('GcHuaNo').AsString;
//  MC_EName := Order_Sub.fieldbyname('C_EName').AsString;
//
//  with Order_Sub do
//  begin
//    DisableControls;
//    First;
//    while not Eof do
//    begin
//      if FieldByName('SSel').AsBoolean then
//      begin
//        Edit;
//        Order_Sub.fieldbyname('C_Code').Value := MC_Code;
//        Order_Sub.fieldbyname('C_Craft').Value := MC_Craft;
//        Order_Sub.fieldbyname('C_Name').Value := MC_Name;
//        Order_Sub.fieldbyname('C_Spec').Value := MC_Spec;
//        Order_Sub.fieldbyname('C_CF').Value := MC_CF;
//        Order_Sub.fieldbyname('C_Color').Value := MC_Color;
//        Order_Sub.fieldbyname('C_MF').Value := MC_MF;
//        Order_Sub.fieldbyname('C_KZ').Value := MC_KZ;
//        Order_Sub.fieldbyname('C_Note').Value := MC_Note;
//        Order_Sub.fieldbyname('C_Unit').Value := MC_Unit;
//        Order_Sub.fieldbyname('SuoLv').Value := MSuoLv;
//        Order_Sub.fieldbyname('GcHuaNo').Value := MGcHuaNo;
//        Order_Sub.fieldbyname('C_EName').Value := MC_EName;
//        Post;
//
//      end;
//      Next;
//    end;
//    EnableControls;
//  end;
//  Order_Sub.Locate('XHNO', MXHNO, []);
end;

procedure TfrmSalesConInPutCopy.PBPriceKeyPress(Sender: TObject; var Key: Char);
begin
  if not (((Key >= '0') and (Key <= '9')) or (Key = '.') or (Key = #8)) then
  begin
    Key := #0;
  end
  else if (pos('.', TEdit(Sender).text) <> 0) then
  begin
    if Key = '.' then
    begin
      Key := #0;
    end;
  end;

end;

procedure TfrmSalesConInPutCopy.Pic_Image1DblClick(Sender: TObject);
begin
  if TcxDBImage(Sender).Picture.Height = 0 then
    exit;

  LookImage(ADOQueryImage.fieldbyname(TcxDBImage(Sender).Hint).asstring);
end;

procedure TfrmSalesConInPutCopy.LookImage(FileName: string);
var
  sFieldName: string;
begin
  sFieldName := leftbstr(ExtractFilePath(Application.ExeName), 1) + ':\图片查看';
  if not DirectoryExists(pchar(sFieldName)) then
    CreateDirectory(pchar(sFieldName), nil);
  sFieldName := sFieldName + '\' + trim(FileName);
  try
    IdFTP1.Host := ReadINIFileStr('SYSTEMSET.INI', 'SERVER', '服务器地址', '127.0.0.1');
    IdFTP1.Username := 'three';
    IdFTP1.Password := '641010';
    IdFTP1.Connect();
  except
    ;
  end;

  if IdFTP1.Connected then
  begin
    try
      IdFTP1.Get(fFlileFlag + '\' + Trim(FileName), sFieldName, true, false);
    except
      Application.MessageBox('客户图样文件不存在', '提示', MB_ICONWARNING);
      IdFTP1.Quit;
      Exit;
    end;
  end
  else
  begin
    Application.MessageBox('无法连接文件服务器', '提示', MB_ICONWARNING);
    IdFTP1.Quit;
    Exit;
  end;
  if IdFTP1.Connected then
    IdFTP1.Quit;
  ShellExecute(Handle, 'open', PChar(sFieldName), '', '', SW_SHOWNORMAL);
end;

procedure TfrmSalesConInPutCopy.QiYunBtnUpClick(Sender: TObject);
var
  fsj: string;
  FWZ: Integer;
begin
  fsj := Trim(TEdit(Sender).Hint);
  FWZ := Pos('/', fsj);
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := Copy(fsj, 1, FWZ - 1);
      flagname := Copy(fsj, FWZ + 1, Length(fsj) - FWZ);
      if ShowModal = 1 then
      begin
        TEdit(Sender).Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmSalesConInPutCopy.ZDYHelp(FButn: TcxButtonEdit; LType: string);
var
  FType, ZDYName, FText: string;
begin
end;

procedure TfrmSalesConInPutCopy.FormShow(Sender: TObject);
begin
  inherited;
  readCxGrid(trim(self.Caption), Tv1, '销售合同管理');
  fFlileFlag := UserDataFlag + 'HX';
  InitData();
  InitImage();
end;

function TfrmSalesConInPutCopy.SaveData(): Boolean;
var
  maxno: string;
  fconNO, fmxType, fDate: string;
begin
  try
    ADOCmd.Connection.BeginTrans;
////////////////       保存主表          //////////////////////
    if Trim(FConMId) = '' then
    begin
      if GetLSNo(ADOTemp, maxno, 'CM', 'BS_Contract_Main', 3, 1) = False then
        raise Exception.Create('取最大号失败！');

      fDate := FormatDateTime('yy', SGetServerDate(ADOTemp));

      if trim(ConNo.Text) = '自动生成' then
      begin
        if GetLSNo(ADOTemp, fconNO, fDate, 'BS_Contract_Main', 4, 0) = False then
          raise Exception.Create('取最合同编号失败！');

        if ConType.Text = '内销' then
          fconNO := 'N' + fconNO
        else
          fconNO := 'W' + fconNO;
        ConNo.Text := fconNO;
      end;
    end
    else
    begin
      maxno := Trim(FConMId);
    end;
    with ADOCmd do
    begin
      Close;
      sql.Clear;
      SQL.Add('select * from BS_Contract_Main where ConMId=''' + Trim(FConMId) + '''');
      Open;
    end;
    with ADOCmd do
    begin
      if Trim(FConMId) = '' then
      begin
        Append;
        FieldByName('Filler').Value := Trim(DName);
        FieldByName('status').Value := '0';
      end
      else
      begin
        Edit;
        FieldByName('Editer').Value := Trim(DName);
        FieldByName('EditTime').Value := SGetServerDateTime(ADOTemp);
      end;
      FieldByName('ConMId').Value := Trim(maxno);
      RTSetsavedata(ADOCmd, 'BS_Contract_Main', ScrollBox1, 2);
      FieldByName('BuyNo').Value := Trim(BuyName.TxtCode);
      FieldByName('SellNo').Value := Sellname.TxtCode;
      FieldByName('MiddleNo').Value := MiddleName.TxtCode;
      Post;
    end;
    with ADOCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from BS_Contract_Main where ConNo=''' + Trim(ConNo.Text) + '''');
      Open;
    end;
    if ADOCmd.RecordCount > 1 then
      raise Exception.Create('合同号重复！');

    FConMId := Trim(maxno);
////////////////       保存主表          //////////////////////
///
////////////////       保存子表          //////////////////////
    with Order_Sub do
    begin
      First;
      while not Eof do
      begin
        maxno := Trim(Order_Sub.fieldbyname('ConSId').AsString);
        with ADOCmd do
        begin
          Close;
          SQL.Clear;
          sql.Add('select * from BS_Contract_Sub where   ConSId=''' + Trim(maxno) + '''');
          Open;
        end;
        with ADOCmd do
        begin
          if ADOCmd.IsEmpty then
            Append
          else
            Edit;
          RTSetSaveDataCDS(ADOCmd, Tv1, Order_Sub, 'BS_Contract_Sub', 0);
          FieldByName('ConMId').Value := Trim(FConMId);
          FieldByName('ConSId').Value := Trim(maxno);

          Post;
        end;
        with Order_Sub do
        begin
          Edit;
          FieldByName('ConSId').Value := Trim(maxno);
          Post;
        end;
        Next;
      end;
    end;
////////////////       保存子表          //////////////////////
///
////////////////       更新合同          //////////////////////
//    with ADOCmd do
//    begin
//      close;
//      sql.Clear;
//      sql.Add('EXEC  P_Con_Up_PiQty   ');
//      sql.Add('@DataID=' + quotedstr(Trim(FConMId)));
//      execsql;
//    end;
////////////////       更新合同          //////////////////////

    ADOCmd.Connection.CommitTrans;
    Result := True;
  except

    ADOCmd.Connection.RollbackTrans;

    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);

    Result := False;
  end;
end;

procedure TfrmSalesConInPutCopy.TBSaveClick(Sender: TObject);
begin
  ConDate.SetFocus;

  if TestData() = false then
    exit;

  if SaveData() then
  begin
    Application.MessageBox('保存成功！', '提示', 0);
  end;
end;

procedure TfrmSalesConInPutCopy.v1PRTOrderQtyPropertiesEditValueChanged(Sender: TObject);
var
  mvalue, FFieldName: string;
  FConQty, FConPrice, FC_Money: Double;        //个数，单价，金额
begin
  mvalue := TcxTextEdit(Sender).EditingText;
  if Trim(mvalue) = '' then
  begin
    mvalue := '0';
  end;
  FFieldName := Trim(Tv1.Controller.FocusedColumn.DataBinding.FilterFieldName);

  with Order_Sub do
  begin
    Edit;
    FieldByName(FFieldName).Value := Trim(mvalue);
    Post;
    FConQty := Fieldbyname('ConQty').AsFloat;
    FConPrice := Fieldbyname('ConPrice').AsFloat;
  end;
  FC_Money := RoundFloat(FConQty * FConPrice, 2);

  with Order_Sub do
  begin
    Edit;
    FieldByName('ConQty').Value := FConQty;
    FieldByName('ConPrice').Value := FConPrice;
    FieldByName('ConTotalAmount').Value := FC_Money;
    Post;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmSalesConInPutCopy.YFTPNameBtnUpClick(Sender: TObject);
begin
  if FConMId = '' then
  begin

  end;
  try
    frmPictureUpload := TfrmPictureUpload.create(self);
    with frmPictureUpload do
    begin
      fFlileFlag := self.fFlileFlag;
      FDataId := trim(Self.FConMId);
      FPictureName := TRIM(YFTPName.Text);
      FWidth := 450;
      FHeight := 600;
//      FTFType := 'HX';
      FTFType := 'YP';
      if showmodal = 1 then
      begin
        Self.YFTPName.Text := frmPictureUpload.FPictureName;
      end;
    end;
  finally
    frmPictureUpload.free;
  end;
  InitImage();
end;

procedure TfrmSalesConInPutCopy.ToolButton1Click(Sender: TObject);
var
  i: Integer;
  maxno: string;
begin
  if GetLSNo(ADOCmd, maxno, 'CS', 'BS_Contract_Sub', 4, 1) = False then
  begin
    ADOCmd.Connection.RollbackTrans;
    Application.MessageBox('取子流水号失败！', '提示', 0);
    Exit;
  end;
  if Trim(ConNo.Text) = '' then
  begin
    Application.MessageBox('合同号不能为空!', '提示', 0);
    Exit;
  end;
  i := Order_Sub.RecordCount;      //当前的dataset有多少行记录
  i := i + 1;
  CopyAddRow(Tv1, Order_Sub);
  with Order_Sub do
  begin
    Edit;
    FieldByName('SSEL').Value := FALSE;
    FieldByName('SerialNo').Value := i;
    FieldByName('ConSId').Value := maxno;
    FieldByName('C_Color').Value := '';
    FieldByName('ConQty').Value := null;
    Post;
  end;
  SetXH();
end;

procedure TfrmSalesConInPutCopy.ToolButton2Click(Sender: TObject);
begin
  if Order_Sub.IsEmpty then
    Exit;
  if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
    Exit;
  while Order_Sub.Locate('SSel', True, []) do
  begin
    with ADOTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from  Trade_Plan_Sub where ConSId=''' + Trim(Order_Sub.fieldbyname('ConSId').AsString) + '''');
      open;
    end;
    if ADOTemp.IsEmpty = false then
    begin
      exit;
      application.MessageBox('该明细已经在生产！', '提示信息');
    end;
    if Trim(Order_Sub.fieldbyname('ConSId').AsString) <> '' then
    begin
      with ADOCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('delete BS_Contract_Sub where ConSId=''' + Trim(Order_Sub.fieldbyname('ConSId').AsString) + '''');
        ExecSQL;
      end;
    end;
    Order_Sub.Delete;
  end;

  SetXH();
end;

procedure TfrmSalesConInPutCopy.ToolButton3Click(Sender: TObject);
begin
  WriteCxGrid(trim(self.Caption), Tv1, '销售合同管理');
end;

procedure TfrmSalesConInPutCopy.Tv1FocusedRecordChanged(Sender: TcxCustomGridTableView; APrevFocusedRecord, AFocusedRecord: TcxCustomGridRecord; ANewItemRecordFocusingChanged: Boolean);
begin
  initGX();
  ConPrice.text := Order_Sub.fieldbyname('ConPrice').AsString;
  ConSid.text := Order_Sub.fieldbyname('ConSid').AsString;

  if Order_Sub.fieldbyname('Estimated').AsString <> '' then
  begin
    with ADOQuery3 do
    begin
      Close;
      SQL.Clear;
      sql.Add(' select * from BS_Contract_Sub ');
      sql.Add('where ConSId=''' + Trim(Order_Sub.fieldbyname('ConSId').AsString) + '''');
//    sql.Add(' order by SerialNo ');
//      ShowMessage(sql.text);
      Open;
    end;
//  SCreateCDS(ADOTemp, Order_Sub);
//  SInitCDSData(ADOTemp, Order_Sub);
    SCSHData(ADOQuery3, ScrollBox2, 0);
    
  end
  else
  begin
    PBPrice.text := '';
    suolv.text := '';
    RPrice.text := '';
    MQty.text := '1';
    GY1Price.text := '';
    GY2Price.text := '';
    GY3Price.text := '';
    PackPrice.text := '';
    exchange.text := '1';
    freight.text := '';
    brokerage.text := '';
    Estimated.text := '';
    profitrate.text := '';
//     suolv.text:='';
  end;

end;

procedure TfrmSalesConInPutCopy.BuyNameBtnUpClick(Sender: TObject);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '客户';
      if Self.FAuthority = '录入' then
        FAuthority := '理单业务';
      if ShowModal = 1 then
      begin
        self.BuyName.TxtCode := Trim(frmCompanySel.CDS_1.fieldbyname('CoCode').AsString);
        self.BuyName.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoAbbrName').AsString);
        self.SalesId.Text := Trim(frmCompanySel.CDS_1.fieldbyname('SalesId').AsString);
        self.Saleser.Text := Trim(frmCompanySel.CDS_1.fieldbyname('Saleser').AsString);
        self.TallyId.Text := Trim(frmCompanySel.CDS_1.fieldbyname('TallyId').AsString);
        self.Tallyer.Text := Trim(frmCompanySel.CDS_1.fieldbyname('Tallyer').AsString);
      end;
    end;

  finally
    frmCompanySel.Free;
  end;

end;

procedure TfrmSalesConInPutCopy.cxDBImage1DblClick(Sender: TObject);
begin
  if TcxDBImage(Sender).Picture.Height = 0 then
    exit;

  LookImage(Qry_ImgHX.fieldbyname(TcxDBImage(Sender).Hint).asstring);
end;

procedure TfrmSalesConInPutCopy.ExchangeRateKeyPress(Sender: TObject; var Key: Char);
begin
  if not (((Key >= '0') and (Key <= '9')) or (Key = '.') or (Key = #8)) then
  begin
    Key := #0;
  end
  else if (pos('.', TEdit(Sender).text) <> 0) then
  begin
    if Key = '.' then
    begin
      Key := #0;
    end;
  end;
end;

procedure TfrmSalesConInPutCopy.Button1Click(Sender: TObject);
var
  FPBPrice, Fsl, Frf, FMQty, FGY1, FGY2, FGY3: Double;
  Fbzf, Fhl, Fyf, Fyj, FXSPrice, FYGCB, FLR: Double;
begin
  FPBPrice := 0;
  Fsl := 0;
  Frf := 0;
  FMQty := 0;
  FGY1 := 0;
  FGY2 := 0;
  FGY3 := 0;
  Fbzf := 0;
  Fhl := 0;
  Fyf := 0;
  Fyj := 0;
  FXSPrice := 0;
  if GY1Price.text <> '' then
  begin
    FGY1 := StrToFloat(GY1Price.text);
  end;
  if GY2Price.text <> '' then
  begin
    FGY2 := StrToFloat(GY2Price.text);
  end;
  if GY3Price.text <> '' then
  begin
    FGY3 := StrToFloat(GY3Price.text);
  end;
  if PBPrice.text <> '' then
  begin
    FPBPrice := StrToFloat(PBPrice.text);
  end
   else
  begin
    Application.MessageBox('坯布价格不能为空!', '提示', 0);
    Exit;
  end;
  if suolv.text <> '' then
  begin
    Fsl := StrToFloat(suolv.text);
  end
  else
  begin

    Application.MessageBox('缩率不能为空!', '提示', 0);
    Exit;

  end;
  if RPrice.text <> '' then
  begin
    Frf := StrToFloat(RPrice.text);
  end;

  if MQty.text <> '' then
  begin
    FMQty := StrToFloat(MQty.text);
  end;
   if PackPrice.text <> '' then
  begin
    Fbzf := StrToFloat(PackPrice.text);
  end;
   if exchange.text <> '' then
  begin
    Fhl := StrToFloat(exchange.text);
  end;
   if freight.text <> '' then
  begin
    Fyf := StrToFloat(freight.text);
  end;

  if brokerage.text <> '' then
  begin
    Fyj := StrToFloat(brokerage.text);
  end
  else
  begin
    Application.MessageBox('佣金不能为空!', '提示', 0);
    Exit;
  end;

  if conPrice.text <> '' then
  begin
    FXSPrice := StrToFloat(conPrice.text);
  end;


  FYGCB := RoundFloat(((((FPBPrice / Fsl + Frf) / FMQty + FGY1 + FGY2 + FGY3 + Fbzf) / Fhl + Fyf) / Fyj), 2);
  FLR := RoundFloat((FXSPrice - FYGCB) / FYGCB, 2)*100;

  Estimated.text := FloatToStr(FYGCB);
  ProfitRate.text := FloatToStr(FLR)+'%';

   if Application.MessageBox('是否要保存！', '提示', 32 + 4) <> IDYES then
    Exit;

  with ADOQuery1 do
  begin
    Close;
    sql.Clear;
    sql.Add(' Update BS_Contract_Sub Set PBPrice=''' + Trim(PBPrice.text) + ''' ');
    sql.Add(',suolv=''' + Trim(suolv.text) + ''',RPrice=''' + Trim(RPrice.text) + ''' ');
    sql.Add(',MQty=''' + Trim(MQty.text) + ''',GY1Price=''' + Trim(GY1Price.text) + ''' ');
    sql.Add(',GY2Price=''' + Trim(GY2Price.text) + ''',GY3Price=''' + Trim(GY3Price.text) + ''' ');
    sql.Add(',PackPrice=''' + Trim(PackPrice.text) + ''',exchange=''' + Trim(exchange.text) + ''' ');
    sql.Add(',freight=''' + Trim(freight.text) + ''',brokerage=''' + Trim(brokerage.text) + ''' ');
    sql.Add(',Estimated=''' + Trim(Estimated.text) + ''',profitrate=''' + Trim(profitrate.text) + ''' ');
    sql.Add(' where ConSid=''' + Trim(Order_sub.fieldbyname('ConSid').AsString) + ''' ');

    ExecSQL;
  end;
end;

procedure TfrmSalesConInPutCopy.BuyNameBtnDnClick(Sender: TObject);
begin
  TBtnEditC(Sender).Text := '';
  TBtnEditC(Sender).TxtCode := '';
end;

procedure TfrmSalesConInPutCopy.v1Column4PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'MPRTCodeName';
      flagname := '产品名称';
      if ShowModal = 1 then
      begin
        Order_Sub.Edit;
        Order_Sub.fieldbyname('PRTCodeName').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        Order_Sub.fieldbyname('PRTCode').Value := Trim(ClientDataSet1.fieldbyname('ZDYNo').AsString);
        Order_Sub.Post;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmSalesConInPutCopy.v1Column6PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'C_MF';
      flagname := '门幅信息';
      if ShowModal = 1 then
      begin
        Order_Sub.Edit;
        Order_Sub.fieldbyname('C_MF').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
     //   Order_Sub.fieldbyname('PRTCode').Value:=Trim(ClientDataSet1.fieldbyname('ZDYNo').AsString);
        Order_Sub.Post;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmSalesConInPutCopy.v1Column7PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'C_KZ';
      flagname := '克重信息';
      if ShowModal = 1 then
      begin
        Order_Sub.Edit;
        Order_Sub.fieldbyname('C_KZ').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
     //   Order_Sub.fieldbyname('PRTCode').Value:=Trim(ClientDataSet1.fieldbyname('ZDYNo').AsString);
        Order_Sub.Post;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmSalesConInPutCopy.v1Column10PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
var
  MCYNo: string;
begin
  frmClothInfoSel := TfrmClothInfoSel.Create(self);
  with frmClothInfoSel do
  begin
    if showmodal = 1 then
    begin
      Order_Sub.Edit;
      Order_Sub.fieldbyname('C_Code').Value := frmClothInfoSel.CDS_1.fieldbyname('C_Code').asstring;

      Order_Sub.fieldbyname('C_Name').Value := frmClothInfoSel.CDS_1.fieldbyname('C_Name').asstring;
      Order_Sub.fieldbyname('C_EName').Value := frmClothInfoSel.CDS_1.fieldbyname('C_EName').asstring;
      Order_Sub.fieldbyname('C_Spec').Value := frmClothInfoSel.CDS_1.fieldbyname('C_Spec').asstring;
      Order_Sub.fieldbyname('C_Composition').Value := frmClothInfoSel.CDS_1.fieldbyname('C_Composition').asstring;
      Order_Sub.fieldbyname('C_Color').Value := frmClothInfoSel.CDS_1.fieldbyname('C_Color').asstring;
      Order_Sub.fieldbyname('C_Width').Value := frmClothInfoSel.CDS_1.fieldbyname('C_Width').asstring;
      Order_Sub.fieldbyname('C_GramWeight').Value := frmClothInfoSel.CDS_1.fieldbyname('C_GramWeight').asstring;
      Order_Sub.Post;
    end;
    free;
  end;

  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmSalesConInPutCopy.SalesmanBtnUpClick(Sender: TObject);
var
  fsj: string;
  FWZ: Integer;
begin
  fsj := Trim(TEdit(Sender).Hint);
  FWZ := Pos('/', fsj);
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := Copy(fsj, 1, FWZ - 1);
      flagname := Copy(fsj, FWZ + 1, Length(fsj) - FWZ);
      if ShowModal = 1 then
      begin
        TEdit(Sender).Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;

end;

procedure TfrmSalesConInPutCopy.v1Column15PropertiesEditValueChanged(Sender: TObject);
var
  mvalue: string;
begin
  mvalue := TcxTextEdit(Sender).EditingText;

  if Trim(mvalue) = '' then
  begin
    mvalue := '0';
  end;
  with Order_Sub do
  begin
    Edit;
    FieldByName('YongJinPrice').Value := mvalue;
    FieldByName('YongJin').Value := FieldByName('YongJinPrice').AsFloat * FieldByName('PRTOrderQty').AsFloat;
    Post;
  end;
end;

procedure TfrmSalesConInPutCopy.SellNameBtnUpClick(Sender: TObject);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '我司';
      if ShowModal = 1 then
      begin
        self.Sellname.TxtCode := Trim(frmCompanySel.CDS_1.fieldbyname('CoCode').AsString);
        self.Sellname.Text := Trim(frmCompanySel.CDS_1.fieldbyname('CoAbbrName').AsString);
      end;
    end;

  finally
    frmCompanySel.Free;
  end;
end;

end.

